﻿using System;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Activation;
using System.IO;
using System.Web;
using System.Runtime.Serialization.Formatters.Binary;
using System.Web.Hosting;
using System.Data;

namespace Data_From_SLGrid.Web
{
    // NOTE: You can use the "Rename" command on the "Refactor" menu to change the class name "Service1" in code, svc and config file together.
    [ServiceContract(Namespace = "")]
    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
    public class Service1
    {
        [OperationContract]
        public void DoWork()
        {
            return;
        }

        public DataTable table()
        {
            DataTable dt = new DataTable("testtable");
            dt.Columns.Add("Topic");
            dt.Columns.Add("TimeGroup");
            dt.Columns.Add("Time");
            dt.Columns.Add("Device");
            dt.Columns.Add("Value");

            dt.Rows.Add(new[] { "topic1", "2005", "Jan", "Device1", "1" });
            dt.Rows.Add(new[] { "topic2", "2006", "Jan", "Device1", "2" });
            dt.Rows.Add(new[] { "topic3", "2007", "Jan", "Device1", "3" });
            dt.Rows.Add(new[] { "topic4", "2008", "Feb", "Device1", "4" });
            dt.Rows.Add(new[] { "topic5", "2009", "Feb", "Device1", "5" });
            dt.Rows.Add(new[] { "topic6", "2010", "Feb", "Device1", "6" });
            dt.Rows.Add(new[] { "topic7", "2011", "Mar", "Device2", "2" });
            dt.Rows.Add(new[] { "topic8", "2012", "Mar", "Device2", "3" });
            dt.Rows.Add(new[] { "topic9", "2013", "Mar", "Device2", "4" });

            return dt;
        }

        [OperationContract]
        public byte[] GetReport()
        {
            System.IO.FileInfo rptPath = new System.IO.FileInfo(HostingEnvironment.MapPath("~/Sample.rdlx"));
            GrapeCity.ActiveReports.PageReport pageReport = new GrapeCity.ActiveReports.PageReport(rptPath);
            GrapeCity.ActiveReports.Export.Rdf.RdfRenderingExtension rdfre = new GrapeCity.ActiveReports.Export.Rdf.RdfRenderingExtension();
            pageReport.Document.LocateDataSource += new GrapeCity.ActiveReports.LocateDataSourceEventHandler(Document_LocateDataSource);
            GrapeCity.ActiveReports.Rendering.IO.MemoryStreamProvider msp = new GrapeCity.ActiveReports.Rendering.IO.MemoryStreamProvider();
            pageReport.Document.Render(rdfre, msp);
            return (msp.GetPrimaryStream().OpenStream() as MemoryStream).ToArray();
        }

        void Document_LocateDataSource(object sender, GrapeCity.ActiveReports.LocateDataSourceEventArgs args)
        {
            args.Data = table();
        }
    }
}
