﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.IO;


namespace Data_From_SLGrid
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }


        private void viewer1_Loaded(object sender, RoutedEventArgs e)
        {
            ServiceReference1.Service1Client client = new ServiceReference1.Service1Client();
            client.GetReportCompleted += new EventHandler<ServiceReference1.GetReportCompletedEventArgs>(client_GetReportCompleted);
            client.GetReportAsync();
        }

        void client_GetReportCompleted(object sender, ServiceReference1.GetReportCompletedEventArgs e)
        {
            System.IO.MemoryStream stream = new System.IO.MemoryStream(e.Result);
            stream.Position = 0;
            GrapeCity.Viewer.Common.StreamDocumentLoader sdl = new GrapeCity.Viewer.Common.StreamDocumentLoader(stream, GrapeCity.Viewer.Common.DocumentFormat.Rdf);
            viewer1.LoadDocument(sdl);
        }
    }
}
